--[[
-- Object-oriented GetV function (2006/04/06)
actor.lua GetV ֐IuWFNgwɂĂ݂
http://blog.livedoor.jp/aidev/archives/50281957.html

the author is null. by Ȟ
http://blog.livedoor.jp/aidev/

documentation by silica as ~̐l
http://winter.sgv417.jp/
--]]
Actor = {}

do
	local getters = {
		id = function( this, key )
			return this()	-- ID擾ĕԂ
		end,
		owner = function( this, key )
			return Actor( GetV( V_OWNER, this.id ) )
		end,
		target = function( this, key )
			return Actor( GetV( V_TARGET, this.id ) )
		end,
		type = function( this, key )
			return GetV( V_TYPE, this.id )
		end,
		attackRange = function( this, key )
			return GetV( V_ATTACKRANGE, this.id )
		end,
		skillAttackRange = function( this, key )
			return function( this, skill )
				return GetV( V_SKILLATTACKRANGE, this.id, skill )
			end
		end,
		homunType = function( this, key )
			return GetV( V_HOMUNTYPE, this.id )
		end,
		motion = function( this, key )
			return GetV( V_MOTION, this.id )
		end,
	--	position = function( this, key )
	--		return GetV( V_POSITION, this.id )	-- ^\bhł͂ЂƂ̒lԂȂہH
	--	end,
		x = function( this, key )
			return GetV( V_POSITION, this.id )
		end,
		y = function( this, key )
			local x, y = GetV( V_POSITION, this.id )
			return y
		end,
		maxhp = function( this, key )
			return GetV( V_MAXHP, this.id )
		end,
		maxsp = function( this, key )
			return GetV( V_MAXSP, this.id )
		end,
		hp = function( this, key )
			return GetV( V_HP, this.id )
		end,
		sp = function( this, key )
			return GetV( V_SP, this.id )
		end,
		distance = function( this, key )
			return function( this, x, y )
				if not y then	-- IDŵƂ
					return GetDistance2( this.id, x )
				else	-- x, y ̂Ƃ
					return GetDistance( this.position, x, y )
				end
			end
		end,
	}
	
	function getter( this, key )	-- getter
		local func = getters[ key ]
		if func then
			return func( this, key )
		else
			return nil
		end
	end
	
	setmetatable( Actor, { __call = function( this, id )	-- RXgN^
		return setmetatable( {}, {
			__newindex = function() end,	-- setter ͉Ȃ
			__index = getter,
			__call = function()	-- ֐ĂяoID̎擾Ɏg
				return id
			end } )
	end } )
end
